unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, EditBtn,
  fppdfobjects, fppdfparser;

type

  { TMainForm }

  TMainForm = class(TForm)
    btnShow: TButton;
    edtPageNo: TEdit;
    FEPDF: TFileNameEdit;
    Label1: TLabel;
    lblPageNo: TLabel;
    lblPageCount: TLabel;
    lblText: TLabel;
    mText: TMemo;
    procedure btnShowClick(Sender: TObject);
  private
    FDoc : TPDFDocument;
    FLoadedFile : string;
    procedure LoadPDF(const aFileName: string);
    procedure ShowPageText(aPageNo: Integer);
  public

  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.LoadPDF(const aFileName : string);

begin
  FreeAndNil(FDoc);
  FDoc:=TPDFDocument.Create;
  Try
    FDoc.LoadFromFile(aFilename);
    FLoadedFile:=aFileName;
    lblPageCount.Caption:='/'+IntToStr(FDoc.PageCount);
  except
    on E : Exception do
      ShowMessage('Error loading PDF file :'+E.Message);
  end;
end;

procedure TMainForm.btnShowClick(Sender: TObject);

Var
  aPage : Integer;

begin
  if (FDoc=Nil) or (FEPDF.FileName<>FloadedFile) then
    LoadPDF(FEPDF.FileName);
  aPage:=StrToIntDef(edtPageNo.Text,0);
  if (aPage>0) and (aPage<FDoc.PageCount) then
    ShowPageText(aPage)
  else
    ShowMessage('Invalid page, valid values 1-'+IntTostr(FDOc.PageCount));
end;

procedure TMainForm.ShowPageText(aPageNo : Integer);

Var
  aPage : TPDFPageObject;
  Cmd : TPDFCommand;
  FontName,Rawtext : RawByteString;
  aFontRef : TPDFRefData;
  UnicodeMap : TPDFCMap;
  aFontObj : TPDFFontObject;

begin
  mText.Clear;
  aPage:=FDoc.Page[aPageNo];
  for Cmd in aPage.CommandList do
     begin
     if Cmd is TPDFTfCommand then
       begin
       FontName:=TPDFTfCommand(Cmd).FontName;
       if (FontName<>'') and (FontName[1]='/') then
         Delete(FontName,1,1);
       aFontRef:=aPage.FindFontRef(FontName);
       aFontObj:=FDoc.FindFont(aFontRef); // TPDFFontObject
       if Assigned(aFontObj) then
         UnicodeMap:=aFontObj.UnicodeCMap
       else
         UnicodeMap:=nil;
       end
     else If cmd is TPDFTextCommand then
      begin
      rawText:=TPDFTextCommand(Cmd).GetFullText(UnicodeMap);
      SetCodePage(RawText,CP_UTF8);
      mText.Lines.Add(RawText);
      end;
    end;
end;

end.

